@(echo off 2>nul 3>nul
start/B mode concols=80lines=22
title GOP Update Tool
pushd "%~dp0"
if exist temporarywork rd/S/Q temporarywork
if not exist "%~1" call:The_End "No file input detected, please drag and drop the firmware file to the batch")
if %~z1 gtr 512000 if %~z1 lss 32768001 goto Size_Pass
call:The_End "Please check the file size and try again"
:Size_Pass
(if not exist *.efi call:The_End "Missing available GOP module files, please confirm and try again"
md temporarywork&&start/B %SystemRoot%\System32\attrib.exe +h +s temporarywork
echo Analyzing firmware...
%SystemRoot%\System32\certutil.exe -encodehex "%~1" temporarywork\FW 4 >nul||call:The_End "Firmware read error, please check and try again"
setlocal enabledelayedexpansion
for /F "tokens=1,2 delims=:" %%i in ('start/B %SystemRoot%\System32\findstr.exe /NRC:"^55 aa .. 00 f1 0e" /C:"^[0d][0e] [01]0 .. .. 00 00 1c 00" /C:"^4e 50 44 45 00 01 10 00" temporarywork\FW')do (
	set raw=%%j
	if /I "%~x1"==".exe" if not defined offset if "!raw:~0,5!"=="55 aa" set/A"offset=-(%%i-1)%%32"
	set/A"rcheck=(%%i!offset!)%%32"
	if !rcheck!==1 (
		set/Anext_line=%%i+2
		set raw[1]=%%j
	)
	if %%i==!next_line! (
		set/Anext_line2=!next_line!+2
		set raw[2]=%%j
	)
	if %%i==!next_line2! (
		set iMCA=!raw:~44,1!
		if 0x!iMCA! lss 5 call:The_End "Unsupported architecture"
		set/An+=1
		set/AiHeader[!n!]=%%i-4
		set iBlock[!n!]=!raw[1]:~6,2!
		set iDID2[!n!]=!raw[2]:~0,2!
		set iDID1[!n!]=!raw[2]:~3,2!
		set iVID2[!n!]=!raw[2]:~6,2!
		set iVID1[!n!]=!raw[2]:~9,2!
		set iClass=!raw[2]:~35,1!
		set iVer[!n!]=!raw:~37,2!
	)
)
if not defined n call:The_End "No GOP module detected"
for /F "eol=C skip=1" %%# in ('start/B %SystemRoot%\System32\certutil.exe -hashfile temporarywork\FW MD4')do set MD4=%%#)
set mod= (MOD)&set iSize=%~z1&if %iMCA%==5 (set MCA=Turing)else if %iMCA%==6 (set MCA=Ampere)else if %iMCA%==7 (set MCA=Ada Lovelace)else set MCA=Unknown
:Check_Loop
set num=&set m=&for %%# in (%iMCA%*.efi)do (
	if /I "%%~x#"==".efi" (
		set "cand=%%~nx#"
		if "0x!cand:~1,2!" gtr "0x%iVer[1]%" (
			if "0x!cand:~3,2!" leq "0x%iBlock[1]%" (
				if not "!m!"=="9" (
					set/Am+=1
					if !m!==1 cls&echo;&echo IFR Subsystem ID	: %iDID1[1]%%iDID2[1]%-%iVID1[1]%%iVID2[1]%&echo Architecture		: %MCA%&echo Module Quantity		: %n%&echo GOP Version		: 0x%iMCA%00%iVer[1]%&(if %n%==2 echo GOP Backup Version	: 0x%iMCA%00%iVer[2]%)&echo GOP Size		: 0x%iBlock[1]%&(if %n%==2 echo GOP Backup Size		: 0x%iBlock[2]%)&echo;&echo [92mPlease select the version to update to.[0m&echo;
					set ELIG[!m!]=!cand!&set num=!num!!m!
					for %%i in (!m!)do for %%j in (!cand:~5^,1!od)do echo  [%%i] 0x%iMCA%00!ELIG[%%i]:~1,2!!%%j!
				)
			)
		)
	)
)
if not defined m call:The_End "No GOP module file higher than version 0x%iMCA%00%iVer[1]% was found"
set/Am+=1
echo;&choice/C %num%%m:~-1% /T 4 /D %m:~-1% /N /M "Please select:"&if errorlevel %m% goto Check_Loop
if exist !ELIG[%errorlevel%]! (set ELIG=!ELIG[%errorlevel%]!)else call:The_End "The required file was not found, please confirm and try again"
(if not exist temporarywork\FW call:The_End "Cache has been deleted, please close unnecessary programs and try again"
for /F "eol=C skip=1" %%# in ('start/B %SystemRoot%\System32\certutil.exe -hashfile temporarywork\FW MD4')do if not "%MD4%"=="%%#" call:The_End "Cache has been modified, please close unnecessary programs and try again"
cls&echo Processing firmware...
start/B %SystemRoot%\System32\certutil.exe -encodehex %ELIG% temporarywork\GOP 4 >nul&pushd temporarywork
set/Anode[1]=iHeader[1]*50+150,node[2]=0x%iBlock[1]%*1600-200,node[3]=iHeader[2]*50+150-node[1]-node[2],node[4]=iSize*25/8-node[1]-node[2]*2-node[3],nodeG[1]=node[2]-4
if not %iBlock[1]%==%ELIG:~3,2% set/A"nodeG[1]=50,nodeG[2]=0x%ELIG:~3,2%*1600-254,fill_vol=(0x%iBlock[1]%-0x%ELIG:~3,2%)*32"&set TypeX2={$node=!nodeG[2]!}else
if not "%iBlock[1]%"=="%iBlock[2]%" set/ATypeB=node[3]=iSize*25/8-node[1]-node[2])
start/B powershell "$fs=[io.file]::OpenRead('GOP');$i=0;$node=%nodeG[1]%;do{$buff=New-Object byte[] $node;$count=$fs.Read($buff,0,$buff.Length);if($count -gt 0){$to='GOP_part{0}' -f ($i);$tf=[io.file]::OpenWrite($to);$tf.Write($buff,0,$count)}if($i -eq 0)%TypeX2%{$node=4};$i++}while($count -gt 0);$tf.Close();$fs.Close()"
powershell "$fs=[io.file]::OpenRead('FW');$i=0;$node=%node[1]%;do{$buff=New-Object byte[] $node;$count=$fs.Read($buff,0,$buff.Length);if($node -ne %node[2]%){$to='part{0}' -f ($i);$tf=[io.file]::OpenWrite($to);try{$tf.Write($buff,0,$count)}finally{$tf.Close()}};if($i -eq 1){$node=%node[3]%}elseif($i -eq 3){$node=%node[4]%}else{$node=%node[2]%};$i++}while($count -gt 0);$fs.Close()"
if defined TypeX2 (set TypeX2=+GOP_part1&set/Pchecksum=<GOP_part2&if not defined TypeB set TypeAX=+GOP_part0+GOP_part1+part4)else set/Pchecksum=<GOP_part1&if not defined TypeB set TypeAX=+GOP_part0+part4
set/Achecksum=0xf%checksum%-0x%iDID1[1]%-0x%iDID2[1]%-0x%iVID1[1]%-0x%iVID2[1]%-0x%iClass%-(0x0%iBlock[1]%-0x0%ELIG:~3,2%)*3,str=checksum/16%%16,tra=checksum%%16
set HEX=0123456789abcdef&set checksum=!HEX:~%str%,1!!HEX:~%tra%,1!
(if defined TypeX2 ((echo ff
for /L %%# in (%fill_vol%,-1,2)do echo ff ff ff ff ff ff ff ff  ff ff ff ff ff ff ff ff
echo ff ff ff ff ff ff ff ff  ff ff ff ff ff ff ff %checksum%)>>GOP_part1
for /F "tokens=1-9*" %%a in (GOP_part0)do echo %%a %%b %%c %%d %%e %%f %%g %%h  %iBlock[1]% %%j>GOP_part0)else echo %checksum%>>GOP_part0
copy/B part0+GOP_part0%TypeX2%+part2%TypeAX% output>nul
popd&endlocal&set oVer=%iMCA%00%ELIG:~1,2%&set oMCA=%iMCA%00%iVer[1]%&set %ELIG:~5,1%=_mod&set iSize=%iSize%&set "oName=%~nx1")
for %%# in (%oMCA%_mod %oMCA%)do call set "oName=%%oName:%%#=%oVer%%m%%%"
if "%oName%"=="%~nx1" set "oName=%~n1_0x%oVer%%m%%~x1"
(if exist "%oName%" del/Q "%oName%"
%SystemRoot%\System32\certutil.exe -decodehex temporarywork\output "%oName%")>nul
for %%# in ("%oName%")do if not "%%~z#"=="%iSize%" (del "%oName%"&call:The_End "Firmware update failed due to unknown error")else call:The_End "[92mGOP has been updated to version 0x%oVer%"
:The_End
rd/S/Q temporarywork
for /F "delims=#" %%i in ('"prompt $E#&for %%# in (#)do rem"')do for /L %%# in (6,-1,1)do cls&echo;&echo [93m%~1.[0m&echo;&echo Automatically close after %%# second...&echo;&echo;&echo;&echo Version 0.4.8 (20230326)&echo Copyright (C) 2021-2023 Wudimobile%%i[?25l&timeout/T 1 >nul
exit